namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "lucky_chant")]
public class LuckyChantEffect : Script, IScriptBlockCriticalHit, IScriptOnEndTurn
{
    private int _turnsLeft = 5;

    /// <inheritdoc />
    public void BlockCriticalHit(IExecutingMove move, IPokemon target, byte hit, ref bool block)
    {
        block = true;
    }

    /// <inheritdoc />
    public void OnEndTurn(IScriptSource owner, IBattle battle)
    {
        _turnsLeft--;
        if (_turnsLeft > 0)
            return;
        RemoveSelf();
    }
}